 
mcmc.risksets2<-function (mcmc, thres = 0.1, file = paste(mcmc$name, "risksets.txt",
    sep = ""), change = NULL, change_from = NULL, change_to = NULL,
    max_risksets = 50, rm.empty = T, rm.empty.riskset0 = F, rm.no.parameters = T,
    min.nr.in.riskset = 1, return = F, env.integer = T, burnin = 0,
    log = F, latex = F,change_all=NULL,strict=F)
{
    vis1 <- mcmc$visit[mcmc$visit$iter > burnin, ]
    info <- mcmc$info
    if (burnin)
        info <- info[-c(1:(burnin/mcmc$thinning)), ]
    iter <- dim(info)[1]
    if (rm.empty.riskset0) {
        keep <- ifelse(vis1$empty != 0, T, F)
        iter <- sum(ifelse(info$empty != 0, 1, 0))
        vis1 <- vis1[keep, ]
    }
    keep <- ifelse(is.na(vis1[, "adj_mean"]), F, T)
    vis1 <- vis1[keep, ]
    keep <- ifelse((vis1[, "nr"]) <= min.nr.in.riskset, F, T)
    if (rm.empty)
        vis1 <- vis1[keep, ]
    write.table(t(c(mcmc$parameter.names, "nr", "adj_mean", "post",
        "post.only", "post.strict", "post.only.strict")), file = file,
        col.names = F, row.names = F, quote = F)
    misc <- ""
    temp <- vis1
    temp[,c(1:mcmc$snp)][temp[,c(1:mcmc$snp)] == 0] <- NA
    if (env.integer & mcmc$env != 0) {
        env.names <- mcmc$parameter.names[-c(1:mcmc$snp)]
        temp[, env.names] <- apply(temp[, env.names] - min(temp,
            na.rm = T), 2, as.integer) + as.integer(min(temp,
            na.rm = T))
    }
    if(!is.null(change_all)){

     for(tal in 1:mcmc$snp){
       if(change_all[tal]==0)
         next
       if(change_all[tal]==1){
         temp[,tal][temp[,tal]==2]<-6
         temp[,tal][temp[,tal]==7]<-1
         temp[,tal][temp[,tal]==5]<-NA
       }
       else{
         temp[,tal][temp[,tal]==2]<-5
         temp[,tal][temp[,tal]==7]<-3
         temp[,tal][temp[,tal]==6]<-NA
       }
     }
    }
    else if (!is.null(change))
        for (tal in 1:length(change)) temp[, change[tal]] <- ifelse(temp[,
            change[tal]] == change_from[tal], change_to[tal],
            temp[, change[tal]])
    if (rm.no.parameters) {
        h <- apply(!is.na(temp[1:(mcmc$snp + mcmc$env)]), 1,
            sum)
        keep <- ifelse(h != 0, T, F)
        temp <- temp[keep, ]
    }
    for (tal in 1:max_risksets) {
        liste <- findRisk(temp, iter = iter, snp = mcmc$snp,
            env = mcmc$env, log = log,strict=strict)
        k <- liste[[1]]
        post <- liste[[2]]
        if (post[1] < thres) {
            post <- dim(temp)[1]/iter
            mean <- round(mean(temp[, "adj_mean"]), 2)
            mean05 <- round(sort(temp[, "adj_mean"])[0.05 * dim(temp)[1]],
                2)
            mean95 <- round(sort(temp[, "adj_mean"])[0.95 * dim(temp)[1]],
                2)
            ind05 <- sort(temp[, "nr"])[0.05 * dim(temp)[1]]
            ind95 <- sort(temp[, "nr"])[0.95 * dim(temp)[1]]
            misc.post <- post
            misc.mean <- mean
            misc.mean05 <- mean05
            misc.mean95 <- mean95
            misc.ind05 <- ind05
            misc.ind95 <- ind95
            break
            cat("SSTTOOPPPP")
        }
        post <- ifelse(post < thres, 1000, post)
        chose <- order(post)[1]
        k <- findRisk(temp, chose = chose, write = T, file = file,
            iter = iter, snp = mcmc$snp, env = mcmc$env, log = log,strict=strict)
        temp <- temp[!k, ]
        if (dim(temp)[1] == 0) {
            post <- dim(temp)[1]/iter
            cat("\n")
            cat("posterior for misc risksets: ", post, " \n")
            break
            cat("SSTTOOPPPP")
        }
    }
    tabel <- read.table(file, header = T, sep = " ")
    keep <- ifelse(mcmc$info[, "empty"] == 0, F, T)
    info <- mcmc$info[keep, ]
    ud <- c()
    for (tal in 1:(mcmc$snp + mcmc$env)) ud[tal] <- ifelse(sum(tabel[,
        tal], na.rm = T) != 0, T, F)
    tab2 <- tabel[, c(ud, T, T, T, T, T, T)]
    tab2[, c((dim(tab2)[2] - 3):dim(tab2)[2])] <- signif(tab2[,
        c((dim(tab2)[2] - 3):dim(tab2)[2])], 2)
    cha <- is.na(tab2)
    tab2[cha] = ""
    tt <- tab2[, 1:table(ud)[2]]
    tt[tt == 1] <- "WT"
    tt[!is.na(tt) & tt == 2] <- "HE"
    tt[!is.na(tt) & tt == 3] <- "HO"
    tt[!is.na(tt) & tt == 5] <- "WT/HE"
    tt[!is.na(tt) & tt == 6] <- "HE/HO"
    tt[!is.na(tt) & tt == 7] <- "WT/HO"
    tab2[, 1:table(ud)[2]] <- tt
    write.table(tab2, file = file)
    if (latex) {
        library(Hmisc)
        latex(tab2)
    }
    riskset <- list(short.table = tab2, misc.post = misc.post,
        misc.mean = misc.mean, misc.mean05 = misc.mean05, misc.mean95 = misc.mean95,
        misc.ind05 = misc.ind05, misc.ind95 = misc.ind95, non.mean = mean(info[,
            "mean"]), non.mean05 = sort(info[, "mean"])[0.05 *
            dim(info)[1]], non.mean95 = sort(info[, "mean"])[0.95 *
            dim(info)[1]], mean.sd = round(mean(info[, "var"]),
            3), non.ind05 = sort(info[, "empty"])[0.05 * dim(info)[1]],
        non.ind95 = sort(info[, "empty"])[0.95 * dim(info)[1]])
    class(riskset) <- "mcmc.risksets"
    return(riskset)
}
