"plot.priors" <-
function(mcmc,col="white",...){
par(mfcol=c(2,2))
norm<-pnorm(mcmc$min.trait,mean=mcmc$mid,sd=mcmc$kappa)+1- pnorm(mcmc$max.trait,mean=mcmc$mid,sd=mcmc$kappa)
curve(dnorm(x,mean=mcmc$mid,sd=mcmc$kappa)/(1-norm),from=mcmc$min.trait,to=mcmc$max.trait,ylim=c(0,dnorm(mcmc$mid,mean=mcmc$mid,sd=mcmc$kappa)/(1-norm)),ylab="Density",xlab="value",main="Prior for the means",...)
pa<-mcmc$prior.active.parameters
Ga<-geo(mcmc$min.active:mcmc$max.active,pa)
norm_a<-sum(Ga)
 barplot(Ga/norm_a,col=col,names=mcmc$min.active:mcmc$max.active,ylab="Density",xlab="Number of active",main="Prior for the number of active",...)
pr<-mcmc$prior.riskset
Gr<-geo(mcmc$min.riskset:mcmc$max.riskset,pr)
norm_r<-sum(Gr)
 barplot(Gr/norm_r,col=col,names=mcmc$min.riskset:mcmc$max.riskset,ylab="Density",xlab="Number of risk sets",main="Priors for the number of risk sets",...)

par(mar=c(0,0,0,0)+.1)
plot(0:1,0:1,axes=F,xlab="",ylab="",col="transparent")
ce=1.2
fo=2
text(0.5,0.9,"uniform prior for the variance",cex=ce,font=fo)
text(0.5,0.75,"uniform prior the distribution
 of the active parameters",cex=ce,font=fo)
text(0.5,0.6,"uniform prior for 
the environmental factors",cex=ce,font=fo)
text(0.5,0.45,paste("prior of the mean: N(",signif(mcmc$mid,3),",",signif((mcmc$kappa^2),3),")",sep=""),cex=ce,font=fo)
text(0.5,0.3,paste("prior for the number of active 
parameters= Geo(",mcmc$prior.active.parameters,")",sep=""),cex=ce,font=fo)
text(0.5,0.15,paste("prior for the number of 
risk sets= Geo(",mcmc$prior.riskset,")",sep=""),cex=ce,font=fo)


par(mar=c(5, 4, 4, 2)+.1)
}

