 
plot.riskset<-function (mcmc, post = T, burnin = 0, col = "white", main = "Posterior distribution for the number of risk sets",
    ylab = "Frequency", xlab = "Number of risk sets", ...)
{
    
    burnin <- burnin/mcmc$thinning
    if (burnin == 0)
        posterior <- mcmc$info[, "nr_r"] - 1
    else
        posterior <- mcmc$info[-c(1:burnin), "nr_r"] - 1
    poster <- mean(posterior != 0)
 
    cat("the posterior probability for at least one riskset=",
        poster, "\n")
    if (post) {
        posterior <- table(posterior)/((mcmc$run - burnin*mcmc$thinning)/mcmc$thinning)
        barplot(posterior, xlab = xlab, ylab = ylab, main = main,
            col = col, ...)
    }
    else {
        barplot(posterior, xlab = xlab, ylab = ylab, col = col,
            ...)
    }

  for(tal in 0:100){
    if(names(posterior)[tal+1]==tal)
      break
    else  
      posterior<-c(0,posterior)  
  }
names(posterior)<-0:(length(posterior)-1)
  obs<-list(posterior=posterior,burnin=burnin*mcmc$thinning)
  class(obs)<-"plot.riskset"
  return(obs)
}


print.plot.riskset<-function(x){
 cum<-rev(cumsum(rev(x$posterior)))
 cum<-c(cum[-1],0)
 mat<-rbind(x$posterior,cum)
 rownames(mat)<-c("p(nm==x)","p(nm>x)")
 print(signif(mat,2))
}

