 
plot.visit<-function (mcmc, burnin = 0, min.in.riskset = 1, main = NULL,
    col = "white", names.arg = mcmc$parameter.names, cex.main = 1,
    post = F, ...)
{
    if (burnin)
        keep <- ifelse(mcmc$visit[, "nr"] >= min.in.riskset &
            mcmc$visit$iter > burnin, TRUE, FALSE)
    else keep <- rep(TRUE, dim(mcmc$visit)[1])
    iter <- (dim(mcmc$info)[1] - burnin/mcmc$thinning)
    if (post) {
        if (is.null(main))
            main = "Posterior for being part of a risk set"
        post <- c()
        for (tal in 1:(mcmc$snp + mcmc$env))
 post[tal] <- sum(tapply(!is.na(mcmc$visit[keep,tal]), mcmc$visit$iter[keep], sum) != 0)/iter
        barplot(post, names.arg = names.arg, main = main, col = col,
            cex.main = cex.main, ...)
        par(cex.axis = 1)
        visit <- list(posterior = post, burnin = burnin, visit = "posterior for being part of a risk set",
            "minimum number in risk set" = min.in.riskset)
        class(visit) <- "visit"
        return(visit)
    }
    else {
        if (is.null(main))
            main = "Average number of visits per iteration"
        sam <- ifelse(!is.na(mcmc$visit[keep, 1:(mcmc$snp + mcmc$env)]), 1, 0)
        par(cex.axis = 0.9)
        mean.visit <- apply(sam, 2, sum)/(mcmc$runtime/mcmc$thinning -
            mcmc$burnin/mcmc$thinning)
        barplot(mean.visit, names.arg = names.arg, main = main,
            cex.main = cex.main, col = col, ...)
        par(cex.axis = 1)
        visit <- list(posterior = mean.visit, burnin = burnin,
            visit = "visits per iteration", "minimum number in risk set" = min.in.riskset)
        class(visit) <- "visit"
        return(visit)
    }
}
