"read.mcmc" <-
function(name){
skip=24
data<-read.table(name,blank.lines.skip=T,fill=T,com="",nrows=skip,colC=rep("character",9),col.names=1:9)

file_1<-data[1,3]
min_trait<-as.numeric(data[2,5])
max_trait<-as.numeric(data[2,7])
mid<-as.numeric(data[3,3])
kappa<-as.numeric(data[4,3])
ind<-as.numeric(data[5,3])
snp<-as.numeric(data[6,3])
env<-as.numeric(data[7,4])
adj<-as.numeric(data[8,3])
max_r<-as.numeric(data[9,7])#max nr risk sets
min_r<-as.numeric(data[10,7])
max_a<-as.numeric(data[11,7])
min_a<-as.numeric(data[12,7])
prior_a<-as.numeric(data[13,9])
prior_r<-as.numeric(data[14,9])
sd_max<-as.numeric(data[15,5])
kappa_multi<-as.numeric(data[16,5])
mu<-data[17,3]
burnin<-as.numeric(data[19,4])
run<-as.numeric(data[20,5])
thinning<-as.numeric(data[21,5])
seed<-as.numeric(data[22,4])
higher<-data[23,2]
start_SD<-as.numeric(data[24,4])

nr_iter<-(run-burnin)/thinning
n.col<-8+env+snp
cat("reading data")

visit<-read.table(name,blank.lines.skip=T,fill=F,col.names=1:n.col,colCla=c("character","integer",rep("integer",snp),rep("numeric",env),"character","integer","character","numeric","character","numeric"),na=0)
cat(" done\n")
burnin<-burnin/thinning
n.col2<-11+adj
cat("reading info")
info<-read.table(name,blank.lines.skip=T,com="%",skip=skip,fill=T,nrows=nr_iter,header=F)
cat(" done\n")
info<-info[,c(2,4,6,8,10,12:(12+adj))]


visit<-visit[,c((3):(snp+env+2),(snp+env+4):(6+snp+env),(snp+env+8),2)]
adj.names<-NULL
if(adj)
adj.names<-paste("adj",1:adj,sep="")


names(info)<-c("iter","like","var","mean","nr_r","empty",adj.names)

names<-NULL
if(snp!=0)
names<-c(paste("SNP",1:snp,sep=""))
if(env!=0)
names<-c(names,paste("ENV",1:env,sep=""))
names(visit)<-c(names,"nr","x","mean","adj_mean","iter")
visit$nr[is.na(visit$nr)]<-0
visit$adj_mean[is.na(visit$adj_mean)]<-0

first<-as.integer(info[1,1])
last<-as.integer(info[dim(info)[1],1])

temp<-visit[,"x"]
temp<-as.factor(temp)
lev<-levels(temp)
lev2<-unlist(strsplit(lev,"u"))

{
if(lev2[1]=="")
lev2<-lev2[1:length(lev)*2]
else
lev2<-lev2[1:length(lev)*2-1]
}
lev3<-unlist(strsplit(lev2,":"))
levels(temp)<-lev3
temp<-as.integer(levels(temp))[as.integer(temp)]
visit[,"x"]<-temp

mcmc<-list(burnin=burnin*thinning,env=env,snp=snp,individuals=ind,info=info,visit=visit,kappa=kappa,kappa.multi=kappa_multi,max.active=max_a,min.active=min_a,max.risksets=max_r,min.risksets=min_r,max.trait=max_trait,min.trait=min_trait,mid=mid,mu=mu,name=name,parameter.names=names,sampels=nr_iter,prior.active.parameters=prior_a,prior.riskset=prior_r,runtime=run,sd.max=sd_max,seed=seed,thinning=thinning,adj=adj,file=file_1)

class(mcmc)<-"BAMSE"
return(mcmc)
}

