with.p<-function (mcmc, data.name, burnin = 10000, ...) 
{
    dat <- read.table(data.name)
    p <- c()
    names(dat)[1] <- "y"
    for (tal2 in 2:(mcmc$snp + 1)) {
        keep<-dat[, tal2]!=0
        x <- factor(dat[keep, tal2])
        ANOVA <- anova(glm(dat$y[keep] ~ 1), glm(dat$y[keep] ~ 1 + x), test = "F")
        p[tal2 - 1] <- ANOVA[2, 6]
    }
    minp <- min(p)
    lab <- signif(10^-(seq(-log(minp, base = 10), 0, by = (log(minp, 
        base = 10)/4))), 2)
    at <- -log(lab, base = 10)
    mm <- at[1]
    at <- at/mm
    pval <- -log(p, base = 10)/mm
    li <- -log(0.05, base = 10)/mm
    li2 <- -log(0.05/mcmc$snp, base = 10)/mm
    par(mar = c(2, 4, 1, 4) + 0.1)
    plot.visit(mcmc, burnin = burnin, post = T, main = "", ylab = "Posterior", 
        names = "", ylim = c(0, 1.05), ...)
    axis(4, at = at, labels = lab)
    points(1:mcmc$snp * 1.2 - 0.5, pval, pch = 4)
    abline(h = li, lty = 2)
    abline(h = li2, lty = 3)
    mtext(paste("SNP 1-",mcmc$snp,sep=""), 1, line = 0.5, cex = 1, font = 1)
    mtext("P-values on log scale", 4, line = 2.5, cex = 1, font = 1)
}
