\name{read.mcmc}
\alias{read.mcmc}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Read BAMSE output }
\description{
  Reads BAMSE output and return an MCMC object
}
\usage{
read.mcmc(name)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{name}{ the path and name of the BAMSE output }
}
\details{
 For large data set this may take several minutes
}
\value{
  \item{burnin}{The burnin from the c++ program (0 unless otherwise specified)}
  \item{env}{the number of environmental factors}
  \item{snp}{the number of SNPs}
  \item{individuals}{the number of individuals}
  \item{info}{a matrix with informtion of each sampled combination of risk sets}
  \item{visit}{a matrix with the sampled risk sets}
  \item{kappa}{kappa (prior for the variance for the means of each risk set)}
  \item{kappa.multi}{the factor that the 1/(squared range) was multiplied with}
  \item{max.active}{the specified maximum active components in each risk set}
  \item{min.active}{the specified minimum active components in each risk set}
  \item{max.risksets}{the specified maximum number of risk sets} 
  \item{min.risksets}{the specified minimum number of risk sets} 
  \item{max.trait}{the upper bound for the means}
  \item{min.trait}{the lower bound for the means}
  \item{mid}{the midrange of the input data}
  \item{mu}{the mean for the prior of the means of the risk sets}
  \item{name}{the name of the BAMSE output file}
  \item{parameter.names}{the names of the parameters (not specified by the user)}
  \item{sampels}{the number of sampels from the Markov chain}
  \item{prior.active}{the parameter specifying the geometric distributed prior for the number of components in a risk set}
  \item{prior.riskset}{the parameter specifying the geometric distributed prior for the number of risk set}
  \item{runtime}{the number of iterations of the Markov chain}
  \item{sd.max}{The maximum allowed standard dividation for the normal distributions}
  \item{seed}{The seed}
  \item{thinning}{The thinning of the samples}
  \item{adj}{the number of adjustment factors}
  \item{file}{the name of the input file}
}
\author{ Anders Albrechtsen }
\keyword{ IO }% at least one, from doc/KEYWORDS

